

   MEMBER()

   MAP
SendMailByMAPI         FUNCTION(String pAddress, String pSubject, String pBody, <String pFiles>, Byte pDialog=0), Byte !Send E-Mail by MAPI-Client
      MODULE('mapi32.dll')
        MapiSendMail(LONG, ULONG, LONG, LONG, LONG), ULONG, PASCAL
      END
   END


SendMailByMAPI       PROCEDURE  (String pAddress, String pSubject, String pBody, <String pFiles>, Byte pDialog=0)

! MAPI structures and equates
!----------------
! Declare a Mapi recipient
mrd             GROUP,PRE()         !MapiRecipDesc
mrd:Reserved      ULONG
mrd:RecipClass    ULONG
mrd:Name          LONG
mrd:Address       LONG
mrd:EIDSize       ULONG
mrd:EntryId       LONG
                END

! Recipient classes
MAPI_TO         EQUATE(1)
MAPI_CC         EQUATE(2)
MAPI_BCC        EQUATE(3)
!----------------

!----------------
! Declare a Mapi message
mm              GROUP,PRE()         !MapiMessage
mm:Reserved       ULONG
mm:Subject        LONG
mm:NoteText       LONG
mm:MessageType    LONG
mm:DateReceived   LONG        ! YYYY/MM/DD HH:MM
mm:ConversationId LONG
mm:Flags          ULONG
mm:Originator     LONG(0)
mm:RecipCount     ULONG
mm:Recips         LONG
mm:FileCount      ULONG
mm:Files          LONG
                END

! Values for Flags
MAPI_UNREAD             EQUATE(1)
MAPI_RECEIPT_REQUESTED  EQUATE(2)
MAPI_SENT               EQUATE(4)
!----------------

!----------------
! Declare a MapiFileDesc
mfd             GROUP,PRE()         !MapiFileDesc
mfd:Reserved      ULONG(0)    ! Reserved for future use (must be 0)
mfd:Flags         ULONG(0)    ! Flags (0 for data file)
mfd:Position      ULONG(-1)   ! character in text to be replaced by attachment (-1=unspecified)
mfd:PathName      LONG        ! LPSTR lpszPathName; Full path name of attachment file
mfd:FileName      LONG        ! LPSTR lpszFileName; Original file name (optional)
mfd:FileType      LONG(0)     ! LPVOID lpFileType;  Attachment file type (can be lpMapiFileTagEx
                END
!----------------

!----------------
! Misc equates
MAPI_LOGON_UI           EQUATE(1)
MAPI_PASSWORD_UI        EQUATE(20000h)
MAPI_NEW_SESSION        EQUATE(2)
MAPI_FORCE_DOWNLOAD     EQUATE(1000h)
MAPI_EXTENDED           EQUATE(20h)
MAPI_DIALOG             EQUATE(8)
!----------------

!----------------
! Something to hold our error, if there is one
mError          ULONG
! The outgoing message information
MapiToEmail     CSTRING(255)                        ! To email address
MapiSubject     CSTRING(255)                        ! Subject of the message
MapiBody        CSTRING(4096)                       ! Body of the message
MapiFileName    CSTRING(255)                        ! FileName to attach
MapiFlags       ULONG
sFlags          LONG
!----------------
MapiErrorText   STRING(50)



  CODE
  ! Assign STRINGS to our CSTRINGS (required by MapiSendMail)
  MapiToEmail  = CLIP(pAddress)
  MapiSubject  = CLIP(pSubject)
  MapiBody     = CLIP(pBody)
  MapiFileName = CLIP(pFiles)
  sFlags       = 0
  IF pDialog THEN sFlags += MAPI_DIALOG .                        !Interactively

  ! Construct a recipient descriptor
  mrd:RecipClass = MAPI_TO
  mrd:Name       = ADDRESS(MapiToEmail)

  ! Construct the message
  mm:Subject    = ADDRESS(MapiSubject)
  mm:NoteText   = ADDRESS(MapiBody)
  mm:Flags      = MapiFlags
  mm:RecipCount = 1
  mm:Recips     = ADDRESS(mrd)

  ! Attach files if there are any
  IF MapiFileName = ''
    ! Nothing to attach
    mm:FileCount = 0
    mm:Files     = 0
  ELSE
    ! Construct the file attachment
    mfd:PathName = ADDRESS(MapiFileName)
    mm:FileCount = 1
    mm:Files     = ADDRESS(mfd)
  END

  ! Send the message
  mError = MapiSendMail(  0,           |          ! session
                          0,           |          ! window
                          ADDRESS(mm), |          ! message
                          sFlags,      |          ! flags
                          0)                      ! reserved

  ! Check for Error
  IF mError
    DO GetMapiErrorText
    MESSAGE('Error: (' & mError & ') ' & MapiErrorText, |
            'Mail delivery error', ICON:Hand, Button:Ok)
    RETURN False
  END
  !
  RETURN True                               !Signal caller that E-mail is send successfully




!=============================================================================
GetMapiErrorText ROUTINE
  MapiErrorText = 'Mapi Error Text for ' & mError & ' is not defined'
  EXECUTE mError
    MapiErrorText = 'Mapi Error User Abort'
    MapiErrorText = 'Mapi Error Failure'
    MapiErrorText = 'Mapi Error Logon Failure'
    MapiErrorText = 'Mapi Error Disk Full'
    MapiErrorText = 'Mapi Error Insufficient Memory'
    MapiErrorText = 'Mapi Error Access Denied'
    MapiErrorText = 'Mapi Error Error Not Defined'
    MapiErrorText = 'Mapi Error Too Many Sessions'
    MapiErrorText = 'Mapi Error Too Many Files'
    MapiErrorText = 'Mapi Error Too Many Recipients'
    MapiErrorText = 'Mapi Error Attachment Not Found'
    MapiErrorText = 'Mapi Error Attachment Open Failure'
    MapiErrorText = 'Mapi Error Attachment Write Failure'
    MapiErrorText = 'Mapi Error Unknown Recipient'
    MapiErrorText = 'Mapi Error Bad Reciptype'
    MapiErrorText = 'Mapi Error No Messages'
    MapiErrorText = 'Mapi Error Invalid Message'
    MapiErrorText = 'Mapi Error Text Too Large'
    MapiErrorText = 'Mapi Error Invalid Session'
    MapiErrorText = 'Mapi Error Type Not Supported'
    MapiErrorText = 'Mapi Error Ambiguous Recipient'
    MapiErrorText = 'Mapi Error Message In Use'
    MapiErrorText = 'Mapi Error Network Failure'
    MapiErrorText = 'Mapi Error Invalid Editfields'
    MapiErrorText = 'Mapi Error Invalid Recips'
    MapiErrorText = 'Mapi Error Not Supported'
  END
  EXIT


